Index: codes/icosagcm/trunk/src/transfert_mpi.f90
===================================================================
--- codes/icosagcm/trunk/src/transfert_mpi.f90	(revision 150)
+++ codes/icosagcm/trunk/src/transfert_mpi.f90	(revision 151)
@@ -1,4 +1,5 @@
 MODULE transfert_mpi_mod
 USE genmod
+USE field_mod
   
   TYPE array
@@ -13,4 +14,10 @@
     REAL,POINTER    :: buffer_r4(:,:,:)
   END TYPE array
+  
+  TYPE t_buffer
+    REAL,POINTER    :: r2(:)
+    REAL,POINTER    :: r3(:,:)
+    REAL,POINTER    :: r4(:,:,:)
+  END TYPE t_buffer    
     
   TYPE t_request
@@ -41,7 +48,17 @@
   TYPE(t_request),POINTER :: req_e0_vect(:)
   
+  TYPE t_message
+    TYPE(t_request), POINTER :: request(:)
+    INTEGER :: nreq
+    INTEGER, POINTER :: mpi_req(:)
+    INTEGER, POINTER :: status(:,:)
+    TYPE(t_buffer),POINTER :: buffers(:) 
+    TYPE(t_field),POINTER :: field(:)
+    LOGICAL :: completed
+    LOGICAL :: pending
+  END TYPE t_message
   
 CONTAINS
-
+  
   SUBROUTINE init_transfert
   USE domain_mod
@@ -70,20 +87,4 @@
       DO j=jj_begin,jj_end+1
         CALL request_add_point(ind,ii_begin-1,j,req_i1)
-      ENDDO    
-    
-      DO i=ii_begin,ii_end
-!        CALL request_add_point(ind,i,jj_begin,req_i1)
-      ENDDO
-
-      DO j=jj_begin,jj_end
-!        CALL request_add_point(ind,ii_end,j,req_i1)
-      ENDDO    
-    
-      DO i=ii_begin,ii_end
-!        CALL request_add_point(ind,i,jj_end,req_i1)
-      ENDDO    
-
-      DO j=jj_begin,jj_end
-!        CALL request_add_point(ind,ii_begin,j,req_i1)
       ENDDO    
     
@@ -142,19 +143,4 @@
       ENDDO   
 
-      DO i=ii_begin+1,ii_end-1
-!        CALL request_add_point(ind,i,jj_begin,req_e1_scal,right)
-!        CALL request_add_point(ind,i,jj_end,req_e1_scal,right)
-      ENDDO
-    
-      DO j=jj_begin+1,jj_end-1
-!        CALL request_add_point(ind,ii_begin,j,req_e1_scal,rup)
-!        CALL request_add_point(ind,ii_end,j,req_e1_scal,rup)
-      ENDDO   
-
-!      CALL request_add_point(ind,ii_begin+1,jj_begin,req_e1_scal,left)
-!      CALL request_add_point(ind,ii_begin,jj_begin+1,req_e1_scal,ldown)
-!      CALL request_add_point(ind,ii_begin+1,jj_end,req_e1_scal,left)
-!      CALL request_add_point(ind,ii_end,jj_begin+1,req_e1_scal,ldown)
-
     ENDDO
 
@@ -211,18 +197,4 @@
       ENDDO   
 
-      DO i=ii_begin+1,ii_end-1
-!        CALL request_add_point(ind,i,jj_begin,req_e1_vect,right)
-!        CALL request_add_point(ind,i,jj_end,req_e1_vect,right)
-      ENDDO
-    
-      DO j=jj_begin+1,jj_end-1
-!        CALL request_add_point(ind,ii_begin,j,req_e1_vect,rup)
-!        CALL request_add_point(ind,ii_end,j,req_e1_vect,rup)
-      ENDDO   
-
-!      CALL request_add_point(ind,ii_begin+1,jj_begin,req_e1_vect,left)
-!      CALL request_add_point(ind,ii_begin,jj_begin+1,req_e1_vect,ldown)
-!      CALL request_add_point(ind,ii_begin+1,jj_end,req_e1_vect,left)
-!      CALL request_add_point(ind,ii_end,jj_begin+1,req_e1_vect,ldown)
   
     ENDDO  
@@ -322,5 +294,5 @@
     target_j=>req%target_j
     target_sign=>req%target_sign
-!    req%max_size=req%max_size*2
+
     ALLOCATE(req%src_domain(req%max_size*2))
     ALLOCATE(req%src_ind(req%max_size*2))
@@ -610,4 +582,532 @@
 
 
+  SUBROUTINE init_message_seq(field, request, message)
+  USE field_mod
+  USE domain_mod
+  USE mpi_mod
+  USE mpipara
+  USE mpi_mod
+  IMPLICIT NONE
+    TYPE(t_field),POINTER :: field(:)
+    TYPE(t_request),POINTER :: request(:)
+    TYPE(t_message) :: message
+
+!$OMP MASTER    
+    message%request=>request
+!$OMP END MASTER    
+!$OMP BARRIER    
+
+  END SUBROUTINE init_message_seq
+
+  SUBROUTINE send_message_seq(field,message)
+  USE field_mod
+  USE domain_mod
+  USE mpi_mod
+  USE mpipara
+  USE omp_para
+  USE trace
+  IMPLICIT NONE
+    TYPE(t_field),POINTER :: field(:)
+    TYPE(t_message) :: message
+
+    CALL transfert_request_seq(field,message%request)
+    
+  END SUBROUTINE send_message_seq
+  
+  SUBROUTINE test_message_seq(message)
+  IMPLICIT NONE
+    TYPE(t_message) :: message
+  END SUBROUTINE  test_message_seq
+  
+   
+  SUBROUTINE wait_message_seq(message)
+  IMPLICIT NONE
+    TYPE(t_message) :: message
+    
+  END SUBROUTINE wait_message_seq    
+
+  SUBROUTINE transfert_message_seq(field,message)
+  USE field_mod
+  USE domain_mod
+  USE mpi_mod
+  USE mpipara
+  USE omp_para
+  USE trace
+  IMPLICIT NONE
+    TYPE(t_field),POINTER :: field(:)
+    TYPE(t_message) :: message
+
+   CALL send_message_seq(field,message)
+    
+  END SUBROUTINE transfert_message_seq    
+    
+    
+  SUBROUTINE init_message_mpi(field,request, message)
+  USE field_mod
+  USE domain_mod
+  USE mpi_mod
+  USE mpipara
+  USE mpi_mod
+  IMPLICIT NONE
+  
+    TYPE(t_field),POINTER :: field(:)
+    TYPE(t_request),POINTER :: request(:)
+    TYPE(t_message) :: message
+
+    TYPE(ARRAY),POINTER :: recv,send 
+    TYPE(t_request),POINTER :: req
+    INTEGER :: irecv,isend
+    INTEGER :: ireq,nreq
+    INTEGER :: ind
+    INTEGER :: dim3,dim4
+
+!$OMP MASTER
+    message%request=>request
+    nreq=sum(request(:)%nsend)+sum(request(:)%nrecv)
+    message%nreq=nreq
+    ALLOCATE(message%mpi_req(nreq))
+    ALLOCATE(message%buffers(nreq))
+    ALLOCATE(message%status(MPI_STATUS_SIZE,nreq))
+    
+    message%pending=.FALSE.
+    message%completed=.FALSE.
+    
+    IF (field(1)%data_type==type_real) THEN
+
+      IF (field(1)%ndim==2) THEN
+      
+        ireq=0
+        DO ind=1,ndomain
+          req=>request(ind)
+      
+          DO isend=1,req%nsend
+            ireq=ireq+1
+            send=>req%send(isend)
+            CALL allocate_mpi_buffer(message%buffers(ireq)%r2,send%size)
+          ENDDO
+        
+          DO irecv=1,req%nrecv
+            ireq=ireq+1
+            recv=>req%recv(irecv)
+            CALL allocate_mpi_buffer(message%buffers(ireq)%r2,recv%size)
+          ENDDO
+        
+        ENDDO
+      
+      
+      ELSE  IF (field(1)%ndim==3) THEN
+    
+        ireq=0
+        DO ind=1,ndomain
+          dim3=size(field(ind)%rval3d,2)
+          req=>request(ind)
+ 
+          DO isend=1,req%nsend
+            ireq=ireq+1
+            send=>req%send(isend)
+            CALL allocate_mpi_buffer(message%buffers(ireq)%r3,send%size,dim3)
+          ENDDO
+        
+          DO irecv=1,req%nrecv
+            ireq=ireq+1
+            recv=>req%recv(irecv)
+            CALL allocate_mpi_buffer(message%buffers(ireq)%r3,recv%size,dim3)
+
+          ENDDO
+        
+        ENDDO
+
+
+      ELSE  IF (field(1)%ndim==4) THEN
+   
+        ireq=0
+        DO ind=1,ndomain
+          dim3=size(field(ind)%rval4d,2)
+          dim4=size(field(ind)%rval4d,3)
+          req=>request(ind)
+
+          DO isend=1,req%nsend
+            ireq=ireq+1
+            send=>req%send(isend)
+            CALL allocate_mpi_buffer(message%buffers(ireq)%r4,send%size,dim3,dim4)
+          ENDDO
+        
+          DO irecv=1,req%nrecv
+            ireq=ireq+1
+            recv=>req%recv(irecv)
+            CALL allocate_mpi_buffer(message%buffers(ireq)%r4,recv%size,dim3,dim4)
+          ENDDO
+        
+        ENDDO
+      
+      ENDIF      
+    ENDIF
+!$OMP END MASTER
+!$OMP BARRIER    
+  END SUBROUTINE init_message_mpi
+  
+  SUBROUTINE barrier
+  USE mpi_mod
+  USE mpipara
+  IMPLICIT NONE
+    
+    CALL MPI_BARRIER(comm_icosa,ierr)
+    
+  END SUBROUTINE barrier  
+    
+  SUBROUTINE transfert_message_mpi(field,message)
+  USE field_mod
+  IMPLICIT NONE
+    TYPE(t_field),POINTER :: field(:)
+    TYPE(t_message) :: message
+    
+    CALL send_message_mpi(field,message)
+    CALL wait_message_mpi(message)
+    
+  END SUBROUTINE transfert_message_mpi
+
+
+  SUBROUTINE send_message_mpi(field,message)
+  USE field_mod
+  USE domain_mod
+  USE mpi_mod
+  USE mpipara
+  USE omp_para
+  USE trace
+  IMPLICIT NONE
+    TYPE(t_field),POINTER :: field(:)
+    TYPE(t_message) :: message
+    REAL(rstd),POINTER :: rval2d(:) 
+    REAL(rstd),POINTER :: rval3d(:,:) 
+    REAL(rstd),POINTER :: rval4d(:,:,:) 
+    REAL(rstd),POINTER :: buffer_r2(:) 
+    REAL(rstd),POINTER :: buffer_r3(:,:) 
+    REAL(rstd),POINTER :: buffer_r4(:,:,:) 
+    INTEGER,POINTER :: value(:) 
+    INTEGER,POINTER :: sgn(:) 
+    TYPE(ARRAY),POINTER :: recv,send 
+    TYPE(t_request),POINTER :: req
+    INTEGER, ALLOCATABLE :: mpi_req(:)
+    INTEGER, ALLOCATABLE :: status(:,:)
+    INTEGER :: irecv,isend
+    INTEGER :: ireq,nreq
+    INTEGER :: ind,n,l,m
+    INTEGER :: dim3,dim4
+
+!$OMP BARRIER
+
+    CALL trace_start("transfert_mpi")
+
+    nreq=message%nreq
+    message%field=>field
+
+!$OMP MASTER
+    message%completed=.FALSE.
+    message%pending=.TRUE.
+!$OMP END MASTER
+    
+    IF (field(1)%data_type==type_real) THEN
+      IF (field(1)%ndim==2) THEN
+
+        ireq=0
+        DO ind=1,ndomain
+          rval2d=>field(ind)%rval2d
+        
+          req=>message%request(ind)
+          DO isend=1,req%nsend
+            ireq=ireq+1
+            send=>req%send(isend)
+            buffer_r2=>message%buffers(ireq)%r2
+            value=>send%value
+
+            CALL trace_in
+
+!$OMP DO SCHEDULE(STATIC)
+            DO n=1,send%size
+              buffer_r2(n)=rval2d(value(n))
+            ENDDO
+            
+            CALL trace_out
+
+!$OMP MASTER
+            CALL MPI_ISSEND(buffer_r2,send%size,MPI_REAL8,send%rank,ind,comm_icosa, message%mpi_req(ireq),ierr)
+!$OMP END MASTER
+          ENDDO
+        
+          DO irecv=1,req%nrecv
+            ireq=ireq+1
+            recv=>req%recv(irecv)
+            buffer_r2=>message%buffers(ireq)%r2
+!$OMP MASTER
+            CALL MPI_IRECV(buffer_r2,recv%size,MPI_REAL8,recv%rank,recv%domain,comm_icosa, message%mpi_req(ireq),ierr)
+!$OMP END MASTER
+          ENDDO
+        
+        ENDDO
+      
+      ELSE  IF (field(1)%ndim==3) THEN
+      
+        ireq=0
+        DO ind=1,ndomain
+          dim3=size(field(ind)%rval3d,2)
+          rval3d=>field(ind)%rval3d
+          req=>message%request(ind)
+ 
+          DO isend=1,req%nsend
+            ireq=ireq+1
+            send=>req%send(isend)
+            buffer_r3=>message%buffers(ireq)%r3
+            value=>send%value
+
+            CALL trace_in
+            
+!$OMP DO SCHEDULE(STATIC)
+              DO n=1,send%size
+                buffer_r3(n,:)=rval3d(value(n),:)
+              ENDDO
+
+             CALL trace_out
+
+!$OMP MASTER
+            CALL MPI_ISSEND(buffer_r3,send%size*dim3,MPI_REAL8,send%rank,ind,comm_icosa, message%mpi_req(ireq),ierr)
+!$OMP END MASTER
+          ENDDO
+        
+          DO irecv=1,req%nrecv
+            ireq=ireq+1
+            recv=>req%recv(irecv)
+            buffer_r3=>message%buffers(ireq)%r3
+!$OMP MASTER           
+            CALL MPI_IRECV(buffer_r3,recv%size*dim3,MPI_REAL8,recv%rank,recv%domain,comm_icosa, message%mpi_req(ireq),ierr)
+!$OMP END MASTER
+
+          ENDDO
+        
+        ENDDO
+
+      ELSE  IF (field(1)%ndim==4) THEN
+    
+        ireq=0
+        DO ind=1,ndomain
+          dim3=size(field(ind)%rval4d,2)
+          dim4=size(field(ind)%rval4d,3)
+          rval4d=>field(ind)%rval4d
+          req=>message%request(ind)
+
+          DO isend=1,req%nsend
+            ireq=ireq+1
+            send=>req%send(isend)
+            buffer_r4=>message%buffers(ireq)%r4
+            value=>send%value
+
+            CALL trace_in
+
+!$OMP DO SCHEDULE(STATIC)
+            DO n=1,send%size
+               buffer_r4(n,:,:)=rval4d(value(n),:,:)
+            ENDDO
+
+           CALL trace_out
+
+!$OMP MASTER
+            CALL MPI_ISSEND(buffer_r4,send%size*dim3*dim4,MPI_REAL8,send%rank,ind,comm_icosa, message%mpi_req(ireq),ierr)
+!$OMP END MASTER
+          ENDDO
+        
+          DO irecv=1,req%nrecv
+            ireq=ireq+1
+            recv=>req%recv(irecv)
+            buffer_r4=>message%buffers(ireq)%r4
+!$OMP MASTER           
+            CALL MPI_IRECV(buffer_r4,recv%size*dim3*dim4,MPI_REAL8,recv%rank,recv%domain,comm_icosa, message%mpi_req(ireq),ierr)
+!$OMP END MASTER
+          ENDDO
+        
+        ENDDO
+      
+      ENDIF      
+      
+    ENDIF
+
+    CALL trace_end("transfert_mpi")
+!$OMP BARRIER
+    
+  END SUBROUTINE send_message_mpi
+  
+  SUBROUTINE test_message_mpi(message)
+  IMPLICIT NONE
+    TYPE(t_message) :: message
+    
+    INTEGER :: ierr
+!$OMP MASTER
+     IF (.NOT. message%pending) RETURN
+!$OMP END MASTER
+
+!$OMP MASTER
+     IF (.NOT. message%completed) CALL MPI_TESTALL(message%nreq,message%mpi_req,message%completed,message%status,ierr)
+!$OMP END MASTER
+  END SUBROUTINE  test_message_mpi
+  
+   
+  SUBROUTINE wait_message_mpi(message)
+  USE field_mod
+  USE domain_mod
+  USE mpi_mod
+  USE mpipara
+  USE omp_para
+  USE trace
+  IMPLICIT NONE
+    TYPE(t_message) :: message
+
+    TYPE(t_field),POINTER :: field(:)
+    REAL(rstd),POINTER :: rval2d(:) 
+    REAL(rstd),POINTER :: rval3d(:,:) 
+    REAL(rstd),POINTER :: rval4d(:,:,:) 
+    REAL(rstd),POINTER :: buffer_r2(:) 
+    REAL(rstd),POINTER :: buffer_r3(:,:) 
+    REAL(rstd),POINTER :: buffer_r4(:,:,:) 
+    INTEGER,POINTER :: value(:) 
+    INTEGER,POINTER :: sgn(:) 
+    TYPE(ARRAY),POINTER :: recv,send 
+    TYPE(t_request),POINTER :: req
+    INTEGER, ALLOCATABLE :: mpi_req(:)
+    INTEGER, ALLOCATABLE :: status(:,:)
+    INTEGER :: irecv,isend
+    INTEGER :: ireq,nreq
+    INTEGER :: ind,n,l,m
+    INTEGER :: dim3,dim4
+
+!$OMP BARRIER
+
+    CALL trace_start("transfert_mpi")
+
+    IF (.NOT. message%pending) RETURN
+    
+    field=>message%field
+    nreq=message%nreq
+    
+    IF (field(1)%data_type==type_real) THEN
+      IF (field(1)%ndim==2) THEN
+
+!$OMP MASTER
+        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
+!$OMP END MASTER
+!$OMP BARRIER
+
+        ireq=0        
+        DO ind=1,ndomain
+          rval2d=>field(ind)%rval2d
+          req=>message%request(ind)
+
+          DO isend=1,req%nsend
+            ireq=ireq+1
+          ENDDO
+     
+          DO irecv=1,req%nrecv
+            ireq=ireq+1
+            recv=>req%recv(irecv)
+            buffer_r2=>message%buffers(ireq)%r2
+            value=>recv%value
+            sgn=>recv%sign
+
+            CALL trace_in
+            
+!$OMP DO SCHEDULE(STATIC)
+            DO n=1,recv%size
+              rval2d(value(n))=buffer_r2(n)*sgn(n)  
+            ENDDO        
+
+            CALL trace_out
+
+          ENDDO
+        
+        ENDDO
+      
+      
+      ELSE  IF (field(1)%ndim==3) THEN
+
+!$OMP MASTER
+        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
+!$OMP END MASTER
+!$OMP BARRIER
+
+        ireq=0        
+        DO ind=1,ndomain
+          rval3d=>field(ind)%rval3d
+          req=>message%request(ind)
+
+          DO isend=1,req%nsend
+            ireq=ireq+1
+          ENDDO
+        
+          DO irecv=1,req%nrecv
+            ireq=ireq+1
+            recv=>req%recv(irecv)
+            buffer_r3=>message%buffers(ireq)%r3
+            value=>recv%value
+            sgn=>recv%sign
+
+            CALL trace_in
+            
+!$OMP DO SCHEDULE(STATIC)
+            DO n=1,recv%size
+              rval3d(value(n),:)=buffer_r3(n,:)*sgn(n)  
+            ENDDO  
+
+            CALL trace_out
+
+          ENDDO
+        
+        ENDDO
+
+      ELSE  IF (field(1)%ndim==4) THEN
+!$OMP MASTER
+        IF (.NOT. message%completed) CALL MPI_WAITALL(nreq,message%mpi_req,message%status,ierr)
+!$OMP END MASTER
+!$OMP BARRIER
+
+        ireq=0        
+        DO ind=1,ndomain
+          rval4d=>field(ind)%rval4d
+          req=>message%request(ind)
+
+          DO isend=1,req%nsend
+            ireq=ireq+1
+          ENDDO
+        
+          DO irecv=1,req%nrecv
+            ireq=ireq+1
+            recv=>req%recv(irecv)
+            buffer_r4=>message%buffers(ireq)%r4
+            value=>recv%value
+            sgn=>recv%sign
+
+            CALL trace_in
+
+!$OMP DO SCHEDULE(STATIC)
+            DO n=1,recv%size
+              rval4d(value(n),:,:)=buffer_r4(n,:,:)*sgn(n) 
+            ENDDO
+
+            CALL trace_out
+
+          ENDDO
+        
+        ENDDO
+      
+      ENDIF      
+      
+    ENDIF
+
+!$OMP MASTER
+    message%pending=.FALSE.
+!$OMP END MASTER
+
+    CALL trace_end("transfert_mpi")
+!$OMP BARRIER
+    
+  END SUBROUTINE wait_message_mpi
+
+
   SUBROUTINE transfert_request_mpi(field,request)
   USE field_mod
@@ -637,5 +1137,5 @@
 
     CALL trace_start("transfert_mpi")
-    
+
     IF (field(1)%data_type==type_real) THEN
       IF (field(1)%ndim==2) THEN
@@ -675,7 +1175,4 @@
         
         CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
-!        DO ind=1,ndomain
-!          field(ind)%rval2d(:)=0.
-!        ENDDO
         
         DO ind=1,ndomain
@@ -739,7 +1236,4 @@
         
         CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
-!        DO ind=1,ndomain
-!          field(ind)%rval2d(:)=0.
-!        ENDDO
         
         DO ind=1,ndomain
@@ -803,7 +1297,4 @@
         
         CALL MPI_WAITALL(nreq,mpi_req,status,ierr)
-!        DO ind=1,ndomain
-!          field(ind)%rval2d(:)=0.
-!        ENDDO
         
         DO ind=1,ndomain
@@ -837,5 +1328,5 @@
   END SUBROUTINE transfert_request_mpi
    
-  SUBROUTINE transfert_request(field,request)
+  SUBROUTINE transfert_request_seq(field,request)
   USE field_mod
   USE domain_mod
@@ -875,5 +1366,5 @@
     ENDDO
     
-  END SUBROUTINE transfert_request
+  END SUBROUTINE transfert_request_seq
   
   
@@ -949,5 +1440,19 @@
         
   END SUBROUTINE gather_field
-  
+
+   
+  SUBROUTINE trace_in
+  USE trace
+  IMPLICIT NONE
+  
+    CALL trace_start("transfert_buffer")
+  END SUBROUTINE trace_in              
+
+  SUBROUTINE trace_out
+  USE trace
+  IMPLICIT NONE
+  
+    CALL trace_end("transfert_buffer")
+  END SUBROUTINE trace_out              
 
 END MODULE transfert_mpi_mod
Index: codes/icosagcm/trunk/src/wind.f90
===================================================================
--- codes/icosagcm/trunk/src/wind.f90	(revision 150)
+++ codes/icosagcm/trunk/src/wind.f90	(revision 151)
@@ -3,4 +3,23 @@
 CONTAINS
 
+  SUBROUTINE un2ulonlat(f_u, f_ulon, f_ulat)
+  USE icosa
+  IMPLICIT NONE
+    TYPE(t_field), POINTER :: f_u(:) ! IN  : normal velocity components on edges
+    TYPE(t_field), POINTER :: f_ulon(:), f_ulat(:) ! OUT : velocity reconstructed at hexagons
+    
+    REAL(rstd),POINTER :: u(:,:),  ulon(:,:), ulat(:,:)
+    INTEGER :: ind
+
+    DO ind=1,ndomain
+       CALL swap_dimensions(ind)
+       CALL swap_geometry(ind)
+       u=f_u(ind)
+       ulon=f_ulon(ind)
+       ulat=f_ulat(ind)
+       CALL compute_un2ulonlat(u,ulon, ulat)
+    END DO
+
+  END SUBROUTINE un2ulonlat
 
  
@@ -214,4 +233,18 @@
  END SUBROUTINE compute_wind_centered_lonlat_compound
 
+ SUBROUTINE compute_un2ulonlat(un, ulon, ulat)
+  USE icosa  
+    
+  IMPLICIT NONE
+  REAL(rstd),INTENT(IN)  :: un(3*iim*jjm,llm)
+  REAL(rstd),INTENT(OUT) :: ulon(iim*jjm,llm)
+  REAL(rstd),INTENT(OUT) :: ulat(iim*jjm,llm)
+
+  REAL(rstd)             :: uc(iim*jjm,3,llm)
+    
+  CALL compute_wind_centered(un,uc)  
+  CALL compute_wind_centered_lonlat_compound(uc, ulon, ulat)
+ 
+ END SUBROUTINE compute_un2ulonlat
 
 END MODULE wind_mod
Index: codes/icosagcm/trunk/src/write_field.f90
===================================================================
--- codes/icosagcm/trunk/src/write_field.f90	(revision 150)
+++ codes/icosagcm/trunk/src/write_field.f90	(revision 151)
@@ -75,5 +75,6 @@
       
       TYPE(t_field),POINTER :: field_glo(:)
-      
+
+!$OMP MASTER      
       IF(PRESENT(once)) THEN
          once_=once
@@ -101,4 +102,5 @@
       
       CALL deallocate_field_glo(field_glo)
+!$OMP END MASTER
       
    END SUBROUTINE writefield
@@ -333,6 +335,4 @@
     USE domain_mod
     USE field_mod
-!    USE dimensions
-!    USE geometry
     IMPLICIT NONE
       CHARACTER(LEN=*),INTENT(IN) :: name_in
@@ -482,8 +482,4 @@
         ENDIF
         
-!        PRINT *,NF90_STRERROR(status)
-!        ncell=ncell+n
-
-!     ENDDO
      
      ELSE IF (Field(ind_b)%field_type==field_Z) THEN
@@ -604,9 +600,4 @@
           ENDDO
         ENDIF
-        
-!        PRINT *,NF90_STRERROR(status)
-!        ncell=ncell+n
-!
-!     ENDDO
      
      ENDIF
@@ -712,9 +703,8 @@
             ENDDO
           ENDDO
-!           DO l=1,size(field(ind)%rval3d,2)
-            status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(1),Field_val3d,  &
+          status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(1),Field_val3d,  &
                                 start=(/ displ+ncell,1,FieldIndex(Index) /), count=(/n,size(field(ind)%rval3d,2),1 /))
-!           ENDDO
           DEALLOCATE(field_val3d)
+
         ELSE IF (field(1)%ndim==4) THEN
 
@@ -732,13 +722,11 @@
               ENDDO
              ENDDO
-!            DO l=1,size(field(ind)%rval4d,2)
+
             status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(q),Field_val3d(:,l), &
                                 start=(/ displ+ncell,l,FieldIndex(Index) /), count=(/n,size(field(ind)%rval4d,2),1 /))
-!            ENDDO
             DEALLOCATE(field_val3d)
           ENDDO         
         ENDIF
         
-!        PRINT *,NF90_STRERROR(status)
         ncell=ncell+n
 
@@ -810,9 +798,9 @@
             ENDDO
           ENDDO
-!           DO l=1,size(field(ind)%rval3d,2)
+
            status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(1),Field_val3d,    &
                                start=(/ displ+ncell,1,FieldIndex(Index) /), count=(/n,size(field(ind)%rval3d,2),1 /))
-!           ENDDO
           DEALLOCATE(field_val3d)
+
         ELSE IF (field(1)%ndim==4) THEN
 
@@ -836,14 +824,10 @@
             ENDDO
 
-!            DO l=1,size(field(ind)%rval4d,2)
-
             status=NF90_PUT_VAR(FieldId(Index),FieldVarId(index)%nc_id(q),Field_val3d,  &
                                 start=(/ displ+ncell,1,FieldIndex(Index) /), count=(/n,size(field(ind)%rval4d,2),1 /))
-!            ENDDO
             DEALLOCATE(field_val3d)
           ENDDO
         ENDIF
         
-!        PRINT *,NF90_STRERROR(status)
         ncell=ncell+n
 
@@ -1159,6 +1143,4 @@
     USE metric
     USE spherical_geom_mod
-!    USE dimensions
-!    USE geometry
     IMPLICIT NONE
       CHARACTER(LEN=*),INTENT(IN) :: name_in
@@ -1292,16 +1274,5 @@
       
         status = NF90_ENDDEF(ncid)      
-
-!        ncell=1
-!        DO ind=ind_b,ind_e
-!          d=>domain_type(ind)
-  
-!          n=0
-!          DO j=d%jj_begin-halo_size,d%jj_end+halo_size
-!            DO i=d%ii_begin-halo_size,d%ii_end+halo_size
-!              IF (single .OR. d%assign_domain(i,j)==ind) n=n+1
-!            ENDDO
-!          ENDDO
-          
+         
          ALLOCATE(lon(ncell),lat(ncell),bounds_lon(0:nvert-1,ncell),bounds_lat(0:nvert-1,ncell))
           
@@ -1330,7 +1301,5 @@
          status=NF90_PUT_VAR(ncid,bounds_latId,REAL(bounds_lat,r8),start=(/ 1,1 /),count=(/ nvert,ncell /))
   
-!         ncell=ncell+n
          DEALLOCATE(lon,lat,bounds_lon,bounds_lat)
-!      END DO 
 
     ELSE IF (Field(ind_b)%field_type==field_Z) THEN
@@ -1416,22 +1385,4 @@
         status = NF90_ENDDEF(ncid)      
 
-!        ncell=1
-!        DO ind=ind_b,ind_e
-!          d=>domain_type(ind)
-!  
-!          n=0
-!          DO j=d%jj_begin+1,d%jj_end
-!            DO i=d%ii_begin,d%ii_end-1
-!              n=n+1
-!            ENDDO
-!          ENDDO
-!
-!          DO j=d%jj_begin,d%jj_end-1
-!            DO i=d%ii_begin+1,d%ii_end
-!              n=n+1
-!            ENDDO
-!          ENDDO
-
-!         ALLOCATE(lon(n),lat(n),bounds_lon(0:nvert-1,n),bounds_lat(0:nvert-1,n))
          ALLOCATE(lon(ncell),lat(ncell),bounds_lon(0:nvert-1,ncell),bounds_lat(0:nvert-1,ncell))
           
@@ -1446,9 +1397,5 @@
                CALL xyz2lonlat(d%vertex(:,vdown,i,j),lon(n),lat(n))
                lon(n)=lon(n)*180/Pi
- !              IF (lon(n)<0) lon(n)=lon(n)+360
                lat(n)=lat(n)*180/Pi
-!               CALL xyz2lonlat(xyz_i(nij,:)/radius,bounds_lon(0,n), bounds_lat(0,n))
-!               CALL xyz2lonlat(xyz_i(nij+t_ldown,:)/radius,bounds_lon(1,n), bounds_lat(1,n))
-!               CALL xyz2lonlat(xyz_i(nij+t_rdown,:)/radius,bounds_lon(2,n), bounds_lat(2,n))
 
                CALL xyz2lonlat(d%xyz(:,i,j),bounds_lon(0,n), bounds_lat(0,n))
@@ -1459,5 +1406,4 @@
                  bounds_lat(k,n)=bounds_lat(k,n)*180/Pi
                  bounds_lon(k,n)=bounds_lon(k,n)*180/Pi
-!                IF (bounds_lon(k,n)<0) bounds_lon(k,n)=bounds_lon(k,n)+360
                ENDDO
              ENDDO
@@ -1468,12 +1414,7 @@
                nij=(j-1)*d%iim+i
                n=n+1
-!              CALL xyz2lonlat(xyz_v(nij+z_up,:)/radius,lon(n),lat(n))
                CALL xyz2lonlat(d%vertex(:,vup,i,j),lon(n),lat(n))
                lon(n)=lon(n)*180/Pi
-!              IF (lon(n)<0) lon(n)=lon(n)+360
                lat(n)=lat(n)*180/Pi
-!              CALL xyz2lonlat(xyz_i(nij,:)/radius,bounds_lon(0,n), bounds_lat(0,n))
-!              CALL xyz2lonlat(xyz_i(nij+t_rup,:)/radius,bounds_lon(1,n), bounds_lat(1,n))
-!              CALL xyz2lonlat(xyz_i(nij+t_lup,:)/radius,bounds_lon(2,n), bounds_lat(2,n))
                CALL xyz2lonlat(d%xyz(:,i,j),bounds_lon(0,n), bounds_lat(0,n))
                CALL xyz2lonlat(d%xyz(:,i,j+1),bounds_lon(1,n), bounds_lat(1,n))
@@ -1483,5 +1424,4 @@
                  bounds_lat(k,n)=bounds_lat(k,n)*180/Pi
                  bounds_lon(k,n)=bounds_lon(k,n)*180/Pi
-!                 IF (bounds_lon(k,n)<0) bounds_lon(k,n)=bounds_lon(k,n)+360
                ENDDO
              ENDDO
@@ -1494,12 +1434,7 @@
          status=NF90_PUT_VAR(ncid,bounds_latId,REAL(bounds_lat,r8),start=(/ 1,1 /),count=(/ nvert,ncell /))
   
-!          ncell=ncell+n
           DEALLOCATE(lon,lat,bounds_lon,bounds_lat)
-!      END DO          
-    ENDIF
-
-
-      
-!      status = NF90_CLOSE(ncid)
+      ENDIF
+
 
     END SUBROUTINE Create_Header_gen
@@ -1783,5 +1718,4 @@
               CALL xyz2lonlat(xyz_v(nij+z_down,:)/radius,lon(n),lat(n))
               lon(n)=lon(n)*180/Pi
- !             IF (lon(n)<0) lon(n)=lon(n)+360
               lat(n)=lat(n)*180/Pi
               CALL xyz2lonlat(xyz_i(nij,:)/radius,bounds_lon(0,n), bounds_lat(0,n))
@@ -1792,5 +1726,4 @@
                 bounds_lat(k,n)=bounds_lat(k,n)*180/Pi
                 bounds_lon(k,n)=bounds_lon(k,n)*180/Pi
-!                IF (bounds_lon(k,n)<0) bounds_lon(k,n)=bounds_lon(k,n)+360
               ENDDO
             ENDDO
@@ -1803,5 +1736,4 @@
               CALL xyz2lonlat(xyz_v(nij+z_up,:)/radius,lon(n),lat(n))
               lon(n)=lon(n)*180/Pi
-!              IF (lon(n)<0) lon(n)=lon(n)+360
               lat(n)=lat(n)*180/Pi
               CALL xyz2lonlat(xyz_i(nij,:)/radius,bounds_lon(0,n), bounds_lat(0,n))
@@ -1812,5 +1744,4 @@
                 bounds_lat(k,n)=bounds_lat(k,n)*180/Pi
                 bounds_lon(k,n)=bounds_lon(k,n)*180/Pi
-!                IF (bounds_lon(k,n)<0) bounds_lon(k,n)=bounds_lon(k,n)+360
               ENDDO
             ENDDO
@@ -1829,8 +1760,5 @@
 
 
-      
-!      status = NF90_CLOSE(ncid)
-
-    end subroutine Create_Header_mpi  
+   END SUBROUTINE Create_Header_mpi  
    
    SUBROUTINE Close_files
